您的位置:首页 > 其它

Codeforces Round #302 (Div. 2)C. Writing Code--dp

2015-06-02 12:20 316 查看
C. Writing Code

time limit per test
3 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

Programmers working on a large project have just received a task to write exactly m lines of code. There are n programmers
working on a project, the i-th of them makes exactly ai bugs
in every line of code that he writes.

Let's call a sequence of non-negative integers v1, v2, ..., vn a plan,
if v1 + v2 + ... + vn = m.
The programmers follow the plan like that: in the beginning the first programmer writes the first v1 lines
of the given task, then the second programmer writes v2 more
lines of the given task, and so on. In the end, the last programmer writes the remaining lines of the code. Let's call a plan good, if all the written lines of the task contain at most b bugs
in total.

Your task is to determine how many distinct good plans are there. As the number of plans can be large, print the remainder of this number modulo given positive integer mod.

Input

The first line contains four integers n, m, b, mod (1 ≤ n, m ≤ 500, 0 ≤ b ≤ 500; 1 ≤ mod ≤ 109 + 7) —
the number of programmers, the number of lines of code in the task, the maximum total number of bugs respectively and the modulo you should use when printing the answer.

The next line contains n space-separated integers a1, a2, ..., an (0 ≤ ai ≤ 500) —
the number of bugs per line for each programmer.

Output

Print a single integer — the answer to the problem modulo mod.

Sample test(s)

input
3 3 3 100
1 1 1


output
10


input
3 6 5 1000000007
1 2 3


output
0


input
3 5 6 11
1 2 1


output
0


因为dp学的比较差,所以这道题也是看别人的思路写出来的

大意n个人写m行代码,第i个人会写出ai个bug,问在bug个数小于b的情况下,方案数是多少
状态dp[j][k]表示写到第j行出现k个bug。那么dp[j][k]=dp[j][k]+dp[j-1][k-a[i]]

#include<stdio.h>

#include<iostream>

#include<string>

#include<string.h>

#include<vector>

#include<algorithm>

#include<queue>

#include<stack>

#include<map>

#define nn 600#define inff 0x3fffffff

#define eps 1e6+100#define ll long long

using namespace std;

int main()

{

    int a[nn];

    int dp[nn][nn]; //DP[I][J]写i行代码bug为j的方案数

    int n,m,b,mod;

    int i,j;

    while(scanf("%d %d %d %d",&n,&m,&b,&mod)!=EOF)

    {

        memset(a,0,sizeof(a));

        for(i=0;i<n;i++)

          scanf("%d",&a[i]);

        memset(dp,0,sizeof(dp));

        dp[0][0]=1;

        for(i=0;i<n;i++)

          for(j=1;j<=m;j++)

            for(int k=0;k<=b;k++)

            {

                if(k<a[i])

                    continue;

                else dp[j][k]=(dp[j][k]+dp[j-1][k-a[i]])%mod;

            }

       int ans=0;

       for(i=0;i<=b;i++)

       {

           ans=(dp[m][i]+ans)%mod;

       }

       printf("%d\n",ans);

    }

}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: